# Please set your working directory
work_dir <- "C:\\Dokumente und Einstellungen\\anha\\Desktop\\diagrammen_gr1\\"

# Do you want to build all Pots directly after loading data
is_build_all_plots = FALSE

#--------------------------------------------------------------------------------

csvpath = paste(work_dir, "fosssecurity.csv", sep="")
setwd(paste(work_dir, "plots", sep=""))

# read cvs-data, drop essay-fields, resort factor levels
fossread.cvsdropessays <- function (path) {
  foss <- read.table(path,
                     header = TRUE,
                     sep = ",",                   
                     comment.char = "",
                     colClasses = c("integer","POSIXct","character","factor","factor",
                                    "factor","factor","factor","factor","NULL",
                                    "factor","factor","NULL","factor","factor",
                                    "NULL","factor","factor","NULL","factor",
                                    "factor","factor","factor","NULL"),
                     strip.white = TRUE,
                     dec=",") 
  
  # resort factor levels (plus restore missing/unused answer-options as factor-levels for plotting):
  foss$RB_CONSIDER_SECURITY_IMPORTANT <- factor(foss$RB_CONSIDER_SECURITY_IMPORTANT, 
       levels=c(levels(foss$RB_CONSIDER_SECURITY_IMPORTANT)[c(4,2,1,3)],"Very unimportant", "Don't know"))
  foss$RB_HOW_MANY_YEARS_SW_DVLPMENT <- factor(foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, 
       levels=levels(foss$RB_HOW_MANY_YEARS_SW_DVLPMENT)[c(4,1,2,3,5)])
  foss$RB_HOW_MANY_YEARS_PARTICIPAT <- factor(foss$RB_HOW_MANY_YEARS_PARTICIPAT, 
       levels=levels(foss$RB_HOW_MANY_YEARS_PARTICIPAT)[c(4,1,2,3,5)])       
  foss$RB_HOW_MANY_PEOPLE <- factor(foss$RB_HOW_MANY_PEOPLE, 
       levels=levels(foss$RB_HOW_MANY_PEOPLE)[c(1,3,2,4,6,5)])                     
  
  return(foss) 
}

# Init global variables
foss <- fossread.cvsdropessays(csvpath)

roles <- c("Bug reporter", "Developer", "Documenter", "Maintainer", "Tester", "Other")
rolesAll <- c("Bug reporter", "Developer", "Documenter", "Maintainer", "Tester", "Other", "N/A")

selfdescrAll <- c("Hacker", "Programmer", "Software Developer", "Software Architect", "Other", "N/A")
selfdescr <- c("Software Developer", "Software Architect", "Other")
selfdescrLab <- c("Software\nDeveloper", "Software\nArchitect", "Other")

yearsSoft <- c("Less than 1", "1-3", "3-5", "6-10", "More than 10")
yearsSoftLab <- c("Less than 1", "1-3", "3-5", "6-10", "More than 10")
yearsFoss <- c("Less than 1", "1-3", "3-5", "6-10", "More than 10")
yearsFossLab <- c("Less than 1", "1-3", "3-5", "6-10", "More than 10")

projTypes <- c("Web information", "System or infrastructure", "Other")
projTypesLab <- c("Web information", "System or\ninfrastructure", "Other")
projSizes <- c("1", "2-10", "10-50", "51-100", "More than 100", "Don't know")
projSizesLab <- c("1", "2-10", "10-50", "51-100", "More than 100", "Don't know")

designMeasures <- c("Deriving requirements for security", "Design for security", "Risk Assessment", "None at all", "Don't know", "Other")
designMeasuresLab <- c("Deriving\nrequirements\nfor security", "Design\nfor security", "Risk\nAssessment", "None at all", "Don't know", "Other")

implMeasures <- c("Coding guidelines", "Code review for security", "None at all", "Don't know", "Other")
implMeasuresLab <- c("Coding\nguidelines", "Code review\nfor security", "None at all", "Don't know", "Other")

testMeasures <- c("Dynamic test tools", "Security audit", "Static test tools", "Unit tests for security", "None at all", "Don't know", "Other")
testMeasureslab <- c("Dynamic\ntest tools", "Security\naudit", "Static\ntest tools", "Unit tests\nfor security", "None at all", "Don't know", "Other")

mainMeasures <- c("Defined workflow for vulnerability fixing", "Patch tracking", "Security team", "None at all", "Don't know", "Other")
mainMeasuresLab <- c("Workflow\nfor vulnerability\nfixing", "Patch\ntracking", "Security\nteam", "None at all", "Don't know", "Other")

importance <- c("Very important", "Important", "Average importance", "Unimportant")
importanceLab <- c("Very\nimportant", "Important", "Average\nimportance", "Unimportant")

percenText <- "Percent of total number of participants (%)"

# Execute all files
if(is_build_all_plots) {
   source(paste(work_dir, "imortance_all.R", sep=""))
   source(paste(work_dir, "importance_roles.R", sep=""))
   source(paste(work_dir, "main_role_all.R", sep=""))
   source(paste(work_dir, "measure_proj_vs_pers.R", sep=""))
   source(paste(work_dir, "measure_proj_vs_pers_people.R", sep=""))
   source(paste(work_dir, "measure_selfdescr.R", sep=""))
   source(paste(work_dir, "measure_years.R", sep=""))
   source(paste(work_dir, "people_all.R", sep=""))
   source(paste(work_dir, "selfdescr_all.R", sep=""))
   source(paste(work_dir, "type_of_project.R", sep=""))
   source(paste(work_dir, "years_all.R", sep=""))
}